import json
import requests
from bs4 import BeautifulSoup

def get_inner_page(page_url):
    page = requests.get(page_url)
    soup = BeautifulSoup(page.content, "lxml")
    item = {}
    firstTable = soup.select(".field-group-format.group_additional > tr")
    for row in firstTable:
        item[row.find("th").get_text()] = row.find("td").get_text()
    secondTable = soup.select('.table-responsive > table > tr')
    for row in secondTable:
        item[row.find('td')[0].get_text()] = row.find('td')[1].get_text()
    if len(soup.select('div[property="content:encoded"]')) > 0:
        item['description'] = soup.select('div[property="content:encoded"]')[0].get_text()
    else: 
        item['description'] = ""
    write_file(item)
def write_file(item):
    with open('out.json', 'a') as f:
        json.dump(item, f)
def start():
    pages = ['https://www.healthdata.gov/search/field_topic/hospital-17821?query=&sort_by=changed&sort_order=DESC']
    for page_url in pages:
        page = requests.get(page_url)
        soup = BeautifulSoup(page.content, "lxml")
        links = soup.select('.search-result-dataset > h2 > a')
        for link in links:
            url = 'https://www.healthdata.gov' + link.get('href')
            get_inner_page(url)
        next_page = soup.select('.pagination.pager .pager-next > a')
        if len(next_page) > 0:
            next_url = 'https://www.healthdata.gov' + next_page[0].get("href")
            pages.append(next_url)
        else:
            next_page = soup.select('.pagination.pager .pager-first > a')
            next_url = 'https://www.healthdata.gov' + next_page[0].get("href")
            pages.append(next_url)

start()