#!/usr/bin/env ruby

require "mechanize"

agent = Mechanize.new { |agent|
  agent.open_timeout = 60
  agent.read_timeout = 60
}
agent.user_agent_alias = 'Windows Mozilla'

urls = ['https://www.healthdata.gov/search/field_topic/hospital-17821?query=&sort_by=changed&sort_order=DESC']

urls.each do |url|
  print "URL: " + url + "\n"
  page = agent.get(url)
  page.search('h2.node-title a').each do |link|
    object = {}
    link_url = link.attr("href")
    print "URL: " + link_url + "\n"
    dp = agent.get(link_url)
    h2 = dp.search('h2.pane-title')
    object['dataset_name'] = h2[3].text()
    d = dp.search('div.field-type-text-with-summary')
    object['dataset_description'] = d.text()
    dp.search('table.group_additional').each do |table|
      table.search('tr').each do |row|
        field = row.search('th.field-label')
        value = row.search('td.field-items')
        if field and field.text() != ""
          object[field.text()] = value.text()
        end
      end
    end
    dp.search('table.table-striped').each do |table|
      table.search('tr').each do |row|
        td = row.search('td')
        if td[0] and td[0].text() != ""
          object[td[0].text()] = td[1].text()
        end
      end
    end
    File.open('ruby.results.json', 'a') { |file| file.write(object.to_json + "\n") }
  end
  li_next = page.search('li.pager-next')
  if li_next
    atag = li_next.search('a')
    if atag.empty?
      print atag
      li_next = page.search('li.pager-first')
      if li_next
        urls.push(li_next.search('a').attr('href'))
      end
    else
      print atag
      urls.push(atag.attr('href'))
    end
   else
    li_next = page.search('li.pager-first')
    if li_next
      urls.push(li_next.search('a').attr('href'))
    end
  end
end
